<?php
namespace Folha\Repositories;

class PtoResumositufreq extends \Doctrine\ORM\EntityRepository
{
    public static function getResumoPorSelecao($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrPeriodoApuracao, $dtPeriodoIni, $dtPeriodoFim, $nrOrgPadrao, $nrOrg, $lote=null)
    {
        /*Caso o início for maior que o fim os dois são invertidos para que a busca seja realizada dentro do intervalo informado*/
        if(($inicio > $fim) and ($criterio != 'NRESTRUTLEGAL')){
            $dsInicio = $fim;
            $dsFim = $inicio;
        }
        else {
            $dsInicio = $inicio;
            $dsFim = $fim;
        }

        /*Verifica se a busca está sendo feita a partir da geração de lote de eventos. Caso 'Sim', só busca os resumos que não possuem lote.*/
        if(is_null($lote)){
            $whereIsLote = '1=1';
        }
        else {
            $whereIsLote = 'RSF.NRLOTELANCEVENTO IS NULL';
        }

        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
           $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
            $sql = "SELECT *
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE (($criterio BETWEEN '$dsInicio' AND '$dsFim')
                                     OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                                    AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                                    AND VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND TO_CHAR(VIH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN ON VIN.NRVINCULOM = RSF.NRVINCULOM
                                                                                                AND VIN.NRORG = RSF.NRORG
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND $whereIsLote";
        } else {
            $sql = "SELECT *
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND TO_CHAR(VIH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN ON VIN.NRVINCULOM = RSF.NRVINCULOM
                                                                                                AND VIN.NRORG = RSF.NRORG
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND $whereIsLote";
        }

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        return (count($result) > 0) ? $result : false;
    }

    public static function getResumoParaLote($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrPeriodoApuracao, $dtPeriodoIni, $dtPeriodoFim, $nrOrgPadrao, $nrOrg)
    {
        /*Caso o início for maior que o fim os dois são invertidos para que a busca seja realizada dentro do intervalo informado*/
        if(($inicio > $fim) and ($criterio != 'NRESTRUTLEGAL')){
            $dsInicio = $fim;
            $dsFim = $inicio;
        }
        else {
            $dsInicio = $inicio;
            $dsFim = $fim;
        }

        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
            $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
            $sql = "SELECT RSF.NRVINCULOM, VIN.NMVINCULOM, SFP.NREVENTOM, EVH.NMEVENTOH, EVH.IDMEDIAVALREF, SUM(RSF.QTREFAPURSITUFREQ) QTREFAPURSITUFREQ
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG, VCM.NMVINCULOM
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE (($criterio BETWEEN '$dsInicio' AND '$dsFim')
                                     OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                                    AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                                    AND VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND TO_CHAR(VIH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN ON VIN.NRVINCULOM = RSF.NRVINCULOM
                                                                                                AND VIN.NRORG = RSF.NRORG
                      LEFT JOIN PTO_SITUFREQPARAM SFP ON SFP.NRSITUFREQUENCIA = RSF.NRSITUFREQUENCIA
                                                     AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
                      LEFT JOIN FPA_EVENTOH EVH ON EVH.NREVENTOM = SFP.NREVENTOM
                                               AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = 0)
                                               /*AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC) FROM FPA_EVENTOH EH
                                                                           WHERE TO_CHAR(EH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia'
                                                                             AND EH.NREVENTOM = EVH.NREVENTOM
                                                                             AND EH.NRORG = EVH.NRORG)*/
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND RSF.NRLOTELANCEVENTO IS NULL
                     GROUP BY RSF.NRVINCULOM, VIN.NMVINCULOM, SFP.NREVENTOM, EVH.NMEVENTOH, EVH.IDMEDIAVALREF";
        } else {
            $sql = "SELECT RSF.NRVINCULOM, VIN.NMVINCULOM, SFP.NREVENTOM, EVH.NMEVENTOH, EVH.IDMEDIAVALREF, SUM(RSF.QTREFAPURSITUFREQ) QTREFAPURSITUFREQ
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG, VCM.NMVINCULOM
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND TO_CHAR(VIH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN ON VIN.NRVINCULOM = RSF.NRVINCULOM
                                                                                                AND VIN.NRORG = RSF.NRORG
                      LEFT JOIN PTO_SITUFREQPARAM SFP ON SFP.NRSITUFREQUENCIA = RSF.NRSITUFREQUENCIA
                                                     AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
                      LEFT JOIN FPA_EVENTOH EVH ON EVH.NREVENTOM = SFP.NREVENTOM
                                               AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = 0)
                                               /*AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC) FROM FPA_EVENTOH EH
                                                                           WHERE TO_CHAR(EH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia'
                                                                             AND EH.NREVENTOM = EVH.NREVENTOM
                                                                             AND EH.NRORG = EVH.NRORG)*/
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND RSF.NRLOTELANCEVENTO IS NULL
                     GROUP BY RSF.NRVINCULOM, VIN.NMVINCULOM, SFP.NREVENTOM, EVH.NMEVENTOH, EVH.IDMEDIAVALREF";
        }

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        return (count($result) > 0) ? $result : false;
    }
}