<?php

namespace Services\Logic\IntegracaoPm;

use Symfony\Component\Config\Definition\Exception\Exception;

class Projeto extends IntegracaoPmLogic
{
    protected $name;
    protected $managerEmail;
    protected $sponsor;
    protected $start;
    protected $end;

    public function __construct() {
        $url = $this->getUtlServicoPm();
        if (!defined("PROJECT_URL")) define("PROJECT_URL", $url."/addProject");
    }

    public function getName() {
        return $this->name;
    }

    public function setName($name) {
        $this->name = $name;
    }

    public function getManagerEmail() {
        return $this->managerEmail;
    }

    public function setManagerEmail($managerEmail) {
        $this->managerEmail = $managerEmail;
    }

    public function getSponsor() {
        return $this->sponsor;
    }

    public function setSponsor($sponsor) {
        $this->sponsor = $sponsor;
    }

    public function getStart() {
        return $this->start;
    }

    public function setStart($start) {
        $this->start = $start;
    }

    public function getEnd() {
        return $this->end;
    }

    public function setEnd($end) {
        $this->end = $end;
    }

    private function getArray() {
        $projeto = array(
            "NAME"    => $this->name,
            "MANAGER" => $this->managerEmail,
            "SPONSOR" => $this->sponsor,
            "START"   => $this->start,
            "END"     => $this->end);
        return $projeto;
    }

    public function salvar() {
        $data = array('requestType' => 'DataSet', 'dataset'=> array(self::getArray()));
        $response = parent::executeCurl(constant("PROJECT_URL"), $data, parent::getHeader());
        if (isset($response["messages"])) {
            throw new \Exception($response["messages"][0]["message"]);
        }
        else {
            return $response["dataset"]["projects"][0]["ID"];
        }
    }

}
