/* +
|          Sistemas Integrados TEKNISA                        	|
|						|
|       Nome: 9306_TEKSQLO_ETLEMAILTEK.sql       	|
|                                                 			|
|   Script para criao da tabela de transaes de E-mail 	|
|                                                 			|
|       Criao:                                  			|
|      - Luiz Passos  -  15/02/2008       			|
|                                                 			|
+ */

CREATE TABLE ETLEMAILTEK
(
	CDFILIAL			VARCHAR(4)	NULL,
	NMORIGEM		VARCHAR2(150)	NULL,
	NMDESTINO		VARCHAR2(150)	NULL,
	ANETLEMAIL		VARCHAR2(4)	NULL,
	MEETLEMAIL		VARCHAR2(4)	NULL,
	DIETLEMAIL		VARCHAR2(4)	NULL,      
	BIETLEMAIL		VARCHAR2(6)	NULL,
	SEETLEMAIL		VARCHAR2(6)	NULL,
	TRETLEMAIL		VARCHAR2(6)	NULL,
	VRVOLDADOS		INT		NULL,
	QTEMAIL		INT		NULL
)
/

CREATE INDEX IDX_00001ETL_EMAILTEK ON ETLEMAILTEK (ANETLEMAIL DESC)
/

CREATE INDEX IDX_00002ETL_EMAILTEK ON ETLEMAILTEK (MEETLEMAIL DESC)
/

CREATE INDEX IDX_00003ETL_EMAILTEK ON ETLEMAILTEK (DIETLEMAIL DESC)
/

/*REGISTRANDO FATOS E DIMENSES*/

BEGIN                                           
   CRIA_FATOS('ETLEMAILTEK', 'VRVOLDADOS',   'Volume de dados',  'E-mail');
   CRIA_FATOS('ETLEMAILTEK', 'QTEMAIL',   'Quantidade de E-mails',   'E-mail');
   
   CRIA_DIME('ETLEMAILTEK',  'CDFILIAL',     	 'Filial',             'FILIAL',      'CDFILIAL',     'NMFILIAL',     NULL); 
   CRIA_DIME('ETLEMAILTEK',  'NMORIGEM',    'Remetente',    NULL,         NULL,           NULL,            NULL);    
   CRIA_DIME('ETLEMAILTEK',  'NMDESTINO',   'Destinatrio',   NULL,         NULL,           NULL,           NULL); 
   CRIA_DIME('ETLEMAILTEK',  'DIETLEMAIL',    'Dia',               NULL,         NULL,            NULL,          NULL); 
   CRIA_DIME('ETLEMAILTEK',  'ANETLEMAIL',  'Ano',               NULL,         NULL,           NULL,          NULL);    
   CRIA_DIME('ETLEMAILTEK',  'MEETLEMAIL',  'Ms',              NULL,         NULL,           NULL,          NULL);    
   CRIA_DIME('ETLEMAILTEK',  'BIETLEMAIL',    'Bimestre',       NULL,         NULL,           NULL,          NULL);    
   CRIA_DIME('ETLEMAILTEK',  'TRETLEMAIL',   'Trimestre',       NULL,         NULL,           NULL,          NULL);    
   CRIA_DIME('ETLEMAILTEK',  'SEETLEMAIL',   'Semestre',      NULL,         NULL,           NULL,          NULL);       
   COMMIT; 
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','5.01.005'); END;
/
