<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

class GpeQuadrovagas extends \Doctrine\ORM\EntityRepository {
    
    public function getVinculosAtivosOcupEstrutHierarq($nrOrg, $dtMesCompetenc, $nrOcupacao, $nrEstrturam): array {
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'           => $nrOrg,
            'P_DTMESCOMPETENC'  => $dtMesCompetenc,
            'P_NRESTRUTURAM'    => $nrEstrturam,
            'P_NROCUPACAOM'     => $nrOcupacao,
        );

        $sql = <<<SQL
            SELECT
                VM.*,
                VH.*
            FROM GPE_VINCULOM VM
            JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG AND VH.NRVINCULOM = VM.NRVINCULOM AND VH.DTMESCOMPETENC = (
                SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH WHERE NRORG = VH.NRORG AND NRVINCULOM = VH.NRVINCULOM AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
            )
            JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG = VM.NRORG
                AND AO.NRVINCULOM = VM.NRVINCULOM
                AND AO.DTINIOCUPACAO = ( SELECT MAX(DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO
                                          WHERE NRORG          = AO.NRORG
                                            AND NRVINCULOM     = AO.NRVINCULOM
                                            AND DTINIOCUPACAO <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')) )
            WHERE VM.NRORG = :P_NRORG
                AND VM.DTRESCISAOVINC IS NULL
                AND AO.NROCUPACAOM = :P_NROCUPACAOM
                AND EXISTS (
                    SELECT 1 FROM (
                        SELECT
                            HIER.NRESTRUTURAMREL
                        FROM HIERARQUIAORG HIER
                        WHERE HIER.NRORG = :P_NRORG
                        START WITH
                            HIER.NRESTRUTURAMREL = :P_NRESTRUTURAM
                        CONNECT BY NOCYCLE
                            PRIOR HIER.NRESTRUTURAMREL = HIER.NRESTRUTURAMSUP
                            AND PRIOR HIER.NRORG = HIER.NRORG
                    ) WHERE NRESTRUTURAMREL = VH.NRESTRUTGEREN
                )
SQL;
        return $db->fetchAll($sql,$params);
    }
    
    public function getQntVinculosAtivosOcupEstrutHierarq($nrOrg, $dtMesCompetenc, $nrOcupacao, $nrEstrturam): int {
        return count($this->getVinculosAtivosOcupEstrutHierarq($nrOrg, $dtMesCompetenc, $nrOcupacao, $nrEstrturam));
    }
    
}