var Dfe27500_NumeracaoInicialTransmissaoNfe_Controller = function(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService) {
    
    var widgetCabecalhoEntrada;
    var CDEMPRESA;
    var CDINSCESTA;
    
    this.setDefaultFilter = function(args) {
        var widget     = args.owner;
        var currentRow = widget.currentRow;
        var row        = { CDEMPRESA: widget.owner.widget.currentRow.CDEMPRESA, CDINSCESTA: widget.owner.widget.currentRow.CDINSCESTA };
        General.callRestEngine("df_entrada#/defaultFilterNumer", "Row", row).then((defaultFilter) =>  {
            defaultFilter = defaultFilter.dataset.defaultFilter;
            var filter = Util.clone(currentRow, ["__rightActions", "__leftActions"]);
            for(var key in defaultFilter) {
                filter[key] = defaultFilter[key];
            }
            widget.getField('CDINSCESTA').readOnly   = false;
            ZhFilterPreferences.setOriginalFilter(widget.id, filter);
            ZhFilterPreferences.openFilterWidget(widget, filter).then(() => {
                if(defaultFilter.CDEMPRESA && defaultFilter.NRINSJURIEST) {
                    widget.getField('CDEMPRESA').dataSourceFilter[0].value   = defaultFilter.CDEMPRESA;
                    widget.getField('CDINSCESTA').dataSourceFilter[1].value = defaultFilter.NRINSJURIEST;
                    widget.getField('NMEMPRESA').reload();
                    widget.getField('CDINSCESTA').reload();
                }
            });
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget);
        });
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    this.empresaOnChange = (widget) => {
        let cnpj = widget.getField("NRINSJURIEST");
        let cnpjFilter = cnpj.dataSourceFilter.find(data => data.name === 'CDEMPRESA');
        
        if(widget.currentRow.CDEMPRESA) cnpjFilter.value = widget.currentRow.CDEMPRESA; 
        
        cnpj.readOnly = !widget.currentRow.CDEMPRESA;
        cnpj.setValue('');
        this.cnpjOnChange(widget);
    };
    
    this.cnpjOnChange = (widget) => {
        let inscricaoEstadual = widget.getField("CDINSCESTA");
        
        if(widget.currentRow.NRINSJURIEST) {
            inscricaoEstadual.dataSourceFilter.forEach( (data) => {
                if(data.name == 'CDEMPRESA')    data.value = widget.currentRow.CDEMPRESA;
                if(data.name == 'NRINSJURIEST') data.value = widget.currentRow.NRINSJURIEST;
            });
        }
        inscricaoEstadual.readOnly = !widget.currentRow.NRINSJURIEST;
        inscricaoEstadual.setValue('');
    };
    
    this.fieldFilterOnChange = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.reload();
    };

    this.setCabecalhoWidgetEntrada = function(widget) {
        widgetCabecalhoEntrada =  widget;
    };
    
    this.getCabecalhoWidgetEntrada = function() {
        return widgetCabecalhoEntrada;
    };
    
    this.getFieldValueNotaFiscalOrigem = function(name) {
        if (widgetCabecalhoEntrada && widgetCabecalhoEntrada.currentRow) 
			return widgetCabecalhoEntrada.currentRow[name];
		else 
			return "";
		
    };
    
    this.actConfirmarOnClick = function(args) {
        var documentosWidget = args.owner.widget;
        var rateioCustosWidget = templateManager.container.getWidget("rateioCustos");
        
        General.callRestEngine("df_entrada#/salvarDocumento", "DataSet", documentosWidget.getCheckedRows()).then((response) => {
            MessageService.successNotificationByCode('REGISTRO_SALVO');
            documentosWidget.unSelectAll();
            documentosWidget.reload();
            rateioCustosWidget.activate();
        });
        
    };
    
    
    this.salvaWidgetOnSaveInlineEdit = function(widget) {
        const vrrateioAlterados = widget.dataSource.data.filter(row =>  !!('changed_VRRATEIO' in row));
        
        General.callRestEngine("df_entrada#/salvaRateioIt", "DataSet", widget.dataSource.data).then((response) => {
            
            MessageService.successNotificationByCode('REGISTRO_SALVO');
            
            vrrateioAlterados.forEach(function(rateio){
                rateio.__is_new = false;
                delete rateio.changed_VRRATEIO;
                delete rateio.changed;
            });
            
            widget.list();
        }).catch((error) => {
            MessageService.showMessageByCode(error.data.error);
            
        });
    };
    
    
    this.actConfirmarComposicaoOnClick = function(args) {
        var row = { "CDFILIAL": this.getFieldValueNotaFiscalOrigem("CDFILIAL"),
                    "NRLANCTONF": this.getFieldValueNotaFiscalOrigem("NRLANCTONF"),
                    "NRORG": this.getFieldValueNotaFiscalOrigem("NRORG")
        };
        
        General.callRestEngine("df_entrada#/confirmarComposicao", "Row", row).then(() => {
            MessageService.showMessageByCode('CONFIRMA_COMPOSICAO');
            ScreenService.openWindow('df_entrada#dfe11000_lancamento_entrada');
        });
        
    };
    
    this.actExcluirDocumentoRelacionado = function(args) {
        var documentosRelacionadosWidget = args.owner.widget;

        General.callRestEngine("df_entrada#/excluirDocumento", "DataSet", documentosRelacionadosWidget.getCheckedRows()).then((response) => {
            MessageService.showMessageByCode('REGISTRO_EXCLUIDO');
            documentosRelacionadosWidget.unSelectAll();
            documentosRelacionadosWidget.reload();

        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe27500_NumeracaoInicialTransmissaoNfe_Controller', Dfe27500_NumeracaoInicialTransmissaoNfe_Controller);
});