const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const produtosImpostosPage = require('../../../page-objects/parametrizacao/documentos fiscais/produtosDiferimentoImpostos.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const percentualGridId = '6063601462002117975858';
const percentualClienteGridId = '6063601461030555962889';
describe('Tela Produtos para Diferimento de Impostos', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		produtosImpostosPage.abrir();
		geral.searchAndClickGridField('NMPAIS', j.getValor('pais'), 'NMPAIS');
		geral.searchAndClickGridField('NMESTADO', j.getValor('estado'), 'NMESTADO');
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar a tela Produtos para Produtos para Diferimento de Impostos', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${percentualGridId}`)));

		expect(z.component.header.getTitle())
			.toBe('Produtos para Diferimento de Impostos');
	});

	it('Adicionar um percentual a um dos produtos dos pré-requisitos', () => {
		geral.clickAdicionar();
		produtosImpostosPage.adicionarPercentual(j.getValor('nomeProduto'), j.getValor('percentual'));
		geral.clickSalvar();

		expect(geral.gridHasText(percentualGridId, j.getValor('percentual'), 2))
			.toBe(j.getValor('percentual'));
	});

	it('Editar o registro adicionado no passo anterior', () => {
		geral.clickGrid('CDARVPROD', j.getValor('codigoProduto'), percentualGridId);
		geral.clickEditar();
		produtosImpostosPage.editarPercentual(j.getValor('percentual1'));
		geral.clickSalvar();

		expect(geral.gridHasText(percentualGridId, j.getValor('percentual1'), 2))
			.toBe(j.getValor('percentual1'));
	});

	it('Excluir o registro adicionado no passo 2', () => {
		geral.clickGrid('CDARVPROD', j.getValor('codigoProduto'), percentualGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(percentualGridId, j.getValor('percentual1'), 2))
			.toBeUndefined();
	});

	it('Adicionar um registro na aba Exceção Percentual(%) por Cliente para o cliente indicado nos pré-requisitos', () => {
		produtosImpostosPage.selectCliente(j.getValor('estado'), j.getValor('inscricaoCliente'));
		geral.clickAdicionar();
		produtosImpostosPage.adicionarPercentual(j.getValor('nomeProduto1'), j.getValor('percentual'));
		geral.clickSalvar();

		expect(geral.gridHasText(percentualClienteGridId, j.getValor('percentual'), 2))
			.toBe(j.getValor('percentual'));
	});

	it('Editar o registro adicionado no passo anterior', () => {
		produtosImpostosPage.selectCliente(j.getValor('estado'), j.getValor('inscricaoCliente'));
		geral.clickGrid('CDARVPROD', j.getValor('codigoProduto1'), percentualClienteGridId);
		geral.clickEditar();
		produtosImpostosPage.editarPercentual(j.getValor('percentual1'));
		geral.clickSalvar();

		expect(geral.gridHasText(percentualClienteGridId, j.getValor('percentual1'), 2))
			.toBe(j.getValor('percentual1'));
	});

	it('Excluir o registro editado anteriormente', () => {
		produtosImpostosPage.selectCliente(j.getValor('estado'), j.getValor('inscricaoCliente'));
		geral.clickGrid('CDARVPROD', j.getValor('codigoProduto1'), percentualClienteGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(percentualClienteGridId, j.getValor('percentual1'), 2))
			.toBeUndefined();
	});
});
